unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, system.UITypes;

type
  TForm1 = class(TForm)
    zEdit: TLabeledEdit;
    calcBtn: TButton;
    ansREdit: TLabeledEdit;
    nEdit: TEdit;
    OneMansEdit: TLabeledEdit;
    Label1: TLabel;
    procedure calcBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;


implementation

{$R *.dfm}

uses Velthuis.BigIntegers, Velthuis.Bigdecimals;

const
  EPSC = '1e-500';                    // Βl
  DPS = 1000;                         // ZL
  precisions : integer = DPS;         // L
  ZINMAX = '32';                      // |z|͍̓ől LƎl̊֌Wł̒l
                                      // LsAl傫ƉZʂ
                                      // 1.0𒴂܂B
//------------------------------------------------------------------------------
// 
// https://www.kurims.kyoto-u.ac.jp/~ooura/pi_fft-j.html
// T.Ooura AGM ASY
function pi_big: Bigdecimal;
var
  n, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
  SQRT_SQRT_EPSILON, c, b, e : BigDecimal;
  npow : Bigdecimal;
  a, one, two, four, five, eight : Bigdecimal;
begin
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := precisions + 5;                             // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  one := '1';
  one := one.RoundToPrecision(dpcs);                  // one̗Ldpcsɐݒ
  two := '2';
  four := '4';
  five := '5';
  eight := '8';
  SQRT_SQRT_EPSILON := one / BigDecimal.IntPower(two, dpcs shl 1); // l
  c := BigDecimal.Sqrt(one / eight, dpcs * 2);
  a := one + c + c + c;
  b := BigDecimal.Sqrt(a, dpcs * 2);
  e := b - five / eight;
  b := b + b;
  c := e - c;
  a := a + e;
  npow := '4';
  n := 0;
  while (e > SQRT_SQRT_EPSILON) and (n < 100) do begin
    npow := npow + npow;                              // 8,16,32,64
    e := (a + b) / two;                               // ϒl ZLł̊ۂ
    b := a * b;
    b := b.RoundToPrecision(dpcs);                    // pcs +  ۂ
    b := BigDecimal.Sqrt(b, dpcs * 2);                // Lł̊ۂ
    e := e - b;
    b := b + b;
    c := c - e;
    a := e + b;
    inc(n);
  end;
  e := e * e;
  e := e.RoundToPrecision(dpcs);                      // pcs +  ۂ
  e := e / four;                                      // e = e * e / 4
  a := a + b;
  result := (a * a - e - e / two) / (a * c - e) / npow;   // Z̏Ԃɒ
  result := result.RoundToPrecision(precisions);          // w̐xɊۂ

  BigDecimal.DefaultPrecision := precisions;              // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;               // Zۂ߃[hA
end;

//------------------------------------------------------------------------------
// erf(z)
function Error_function(z : bigdecimal): bigdecimal;
var
  mzh2, zhn, s, tmp : bigdecimal;
  epsilon, pai2, sabs : bigdecimal;
  one, two, n, nl, nn : bigdecimal;
  dpcs : integer;
begin
  dpcs := precisions;                             // ZL
  epsilon := EPSC;                                // l
  one := bigdecimal.One;                          // 1
  two := one + one;                               // 2
  pai2 := pi_big;                                 // 
  pai2 := two / pai2.Sqrt(pai2, dpcs + dpcs);     // 2/()
  mzh2 := -z * z;                                 // -z^2
  s := z;                                         // n = 0  z
  nl := one;                                      // 0! = 1
  zhn := z;                                       // n = 0  z
  n := one;                                       // n=1
  repeat
    nn := n + n + one;                            // 2n+1
    nn := nn * nl;                                // n!(2n+1)
    zhn := zhn * mzh2;                            // ((-1)^n)(z^(2n+1))
    nn := nn.RoundToPrecision(dpcs);              // ZO킹
    zhn := zhn.RoundToPrecision(dpcs);            // ZO킹
    tmp := zhn / nn;                              // ((-1)^n)(z^(2n+1))/(n!(2n+1))
    s := s + tmp;                                 // +
    n := n + one;                                 // inc(n)
    nl := nl * n;                                 // n!
    sabs := tmp.Abs(tmp);                         // ||
  until sabs < epsilon;
  result := s * pai2;                             // * 2/()
  form1.nedit.Text := 'loops= ' + n.ToString;
end;

//------------------------------------------------------------------------------
// 0.99E9xxx9̒l𐔂ƓɌ̒l0.99E9xxx-0.99E90.00Exxx𓾂܂B
function nineNo(x : bigdecimal; var ans: bigdecimal): integer;
const
  NINE = '9';
var
  char9 : char;
  i, lng, count : integer;
  str, ninestr : string;
  s9f : boolean;
  nines : bigdecimal;
begin
  s9f := false;
  char9 := NINE;
  str := x.ToPlainString;
  lng := length(str);
  ninestr := '0.';
  count := 0;
  for i := 1 to lng do begin
    if str[i] = char9 then begin
      if i = 3 then s9f := true;
      if s9f then begin
        inc(count);
        ninestr := ninestr + char9;
      end;
    end
    else s9f := false;
  end;
  if count > 0 then begin
    nines := ninestr;
    ans := x - nines;
  end
  else ans := x;
  result := count;
end;

//------------------------------------------------------------------------------
// error function calc
// z̒lerror֐̒l1ɂȂ̂łAZ̊֌W
// 50\z̒l10.7x1ɂȂĂ܂9̐ł̕\̗pĂ܂B
Procedure calc_error_function;
var
  z, absz, ans, mans, ansm99, zmax, one, ansmone : bigdecimal;
  nineN, dispn : integer;
  str99 : string;
begin
  zmax := ZINMAX;
  try
    z := form1.zEdit.Text;
  except
    on EConverterror do begin
      MessageDlg('z ̒lɊԈႢ܂B', mtError, [mbOK], 0);
      exit;
    end;
  end;
  absz := z.Abs(z);
  if absz > zmax then begin
    MessageDlg('z ̐ΒlZ̍ől傫ȂĂ܂B', mtError, [mbOK], 0);
    exit;
  end;
  one := bigdecimal.One;

  // error ֐vZ
  ans := Error_function(z);
  // errorC ֐vZ
  mans := bigdecimal.One - ans;

  // z̒l1.2𒴂0.999EE99̒l9̒l𐔂ŕ\ 0. + 9̐{0.99E9ZlƂĕ\
  if z >= 0 then nineN := nineNo(ans, ansm99)
            else nineN := nineNo(-ans, ansm99);

  dispn := 50 - nineN;
  if dispn < 3 then dispn := 5;

  if nineN = 0 then ansm99 := ansm99.RoundToPrecision(50)
               else ansm99 := ansm99.RoundToPrecision(dispn);

  if ans = '0' then form1.ansREdit.Text := '0.0'
  else begin
    if nineN > 0 then begin
      if ansm99 = bigdecimal.Zero then str99 := '0'
                                  else str99 := ansm99.ToString;
      if z >= 0 then Form1.ansREdit.Text := '0. 9xx' + inttostr(nineN) + ' + ' + str99
                else Form1.ansREdit.Text := '-0. 9xx' + inttostr(nineN) + ' - ' + str99;
    end
    else begin
      ans := ans.RoundToPrecision(50);
      Form1.ansREdit.Text := ans.ToString;
    end;
  end;

  if mans > one then ansmone := mans - one
                else ansmone := mans;
  nineN := nineNo(ansmone, ansm99);

  dispn := 50 - nineN;
  if dispn < 3 then dispn := 5;

  if nineN = 0 then ansm99 := ansm99.RoundToPrecision(50)
               else ansm99 := ansm99.RoundToPrecision(dispn);

  if nineN > 0 then begin
    if ansm99 = bigdecimal.Zero then str99 := '0'
                                else str99 := ansm99.ToString;
    if mans > one then Form1.OneMansEdit.Text := '1. 9xx' + inttostr(nineN) + ' + ' + str99
                  else Form1.OneMansEdit.Text := '0. 9xx' + inttostr(nineN) + ' + ' + str99;
  end
  else begin
    mans := mans.RoundToPrecision(50);
    form1.OneMansEdit.Text := mans.ToString;
  end;
end;

//------------------------------------------------------------------------------
// LƎl̃ftHglZbg@
procedure TForm1.calcBtnClick(Sender: TObject);
begin
  bigdecimal.DefaultPrecision := DPS;
  calc_error_function;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  zedit.EditLabel.Caption := '|z|<=' + ZINMAX;
  label1.Caption := 'Z̒l̎erf()=1ƂȂ̂łZ͂̍ől' + ZINMAX + 'łB';
  nEdit.Text := 'loops ='
end;

end.
